Require Import ImpureConfig.
Require Import DemoPLVerifier.
Require Import ExtrOcamlString.
Import Debugging.
Import CertC.

Set Extraction AccessOpaque.

(** Debugging 
in order to debug, you need to:
  - comment the normal "mode"
  - decomment the debugging "mode" 
*)
(* begin: normal mode *) 
(* Extraction Inline failwith. *)
(* Extraction Inline trace. *)
(* end: normal mode *)

(* begin: debugging code *)
Extract Inlined Constant failwith =>
   "(fun l _ -> failwith (CoqPr.charListTr l))".

(* If needed, change the global mode below in the first arg of [trace_cmp]. *)
Extract Inlined Constant trace =>
   "(fun mode l a -> if (Debugging.traceCmp INFO mode) then (print_string (CoqPr.charListTr l); print_newline()); a)".
(* end: debugging code *)


Extract Inlined Constant Cert.id_t => "int".
Extract Inlined Constant Cert.eqId => "(=)".
Extract Inlined Constant Cert.shift => "(+)".
Extract Inlined Constant Cert.idPr => "(fun i -> CoqPr.stringTr (string_of_int i))".

Extract Inlined Constant CoqAddOn.posPr => "CoqPr.posPr'".
Extract Inlined Constant CoqAddOn.posPrRaw => "CoqPr.posPrRaw'".
Extract Inlined Constant CoqAddOn.zPr => "CoqPr.zPr'".
Extract Inlined Constant CoqAddOn.zPrRaw => "CoqPr.zPrRaw'".

Extract Inlined Constant Backend.t => "Pol.t".
Extract Inlined Constant Backend.pr => "(fun p -> CoqPr.stringTr (Pol.prExtRaw p))".
Extract Inlined Constant Backend.freshId => "Pol.get_nxt".
Extract Inlined Constant Backend.top => "Pol.top".
Extract Inlined Constant Backend.isEmpty => "Support.isEmpty".
Extract Inlined Constant Backend.isIncl => "Support.isIncl".
Extract Inlined Constant Backend.add => "Support.add".
Extract Inlined Constant Backend.addp => "Support.addp".
Extract Inlined Constant Backend.meet => "Support.meet".
Extract Inlined Constant Backend.join => "Support.join".
Extract Inlined Constant Backend.widen => "Support.widen".
Extract Inlined Constant Backend.getItv => "Support.getItv".
Extract Inlined Constant Backend.getLowerBound => "Support.getLowerBound".
Extract Inlined Constant Backend.getUpperBound => "Support.getUpperBound".
Extract Inlined Constant Backend.project => "Support.project".
Extract Inlined Constant Backend.rename => "Support.rename".

Extract Inlined Constant LinearizeBackend.oracle => "Oracle.oracle".

Extract Inductive bool => "bool" [ "true" "false" ].
Extract Inductive sumbool => "bool" [ "true" "false" ].
Extract Inductive option => "option" [ "Some" "None" ].
Extract Inductive unit => "unit" [ "()" ].
Extract Inductive list => "list" [ "[]" "(::)" ].
Extract Inductive prod => "(*)" [ "(,)" ].

Extraction Blacklist List String.

Extraction Inline value error.
Extraction Inline imp bind pure.

Separate Extraction Debugging DemoPLVerifier
 (* for compatibility with vpl/lib: *) PedraQ Backend Itv.
