Require Import ImpureConfig.
Require Import ASTerm.
Require Import ZNoneItv.
Require Import LinTerm.

Record linearizeContext: Type := {
  nonaffine: ZTerm.t;     (* non-affine part of the term *)
  env: PVar.t -> ZNItv.t; (* environment *)
  affine: ZAffTerm.t;     (* affine part *)
  source: ZTerm.t;        (* source = nonaffine + affine *) 
  cmp: cmpG               (* guard: "0 cmp source" *)
}.

(** The oracle is expected to return a polynomial which equals to lc.nonaffine.
*) 

Axiom oracle: linearizeContext -> imp ZTerm.t.

(* The implementation below is provided as a default stub ! 

IMPORTANT: keep oracle as a lemma in order to ensure that the default implementation is not used in proofs.
*)

(*

Lemma oracle (lc:linearizeContext): imp ZTerm.t.
Proof.
  exact (pure (nonaffine lc)).
Qed.
Global Opaque oracle.

*)