let charListTr: char list -> string
= fun l ->
(*
	let s = String.create (List.length l) in
	let _ = List.fold_left (fun i c -> String.set s i c; i + 1) 0 l in
	s
*)
  let buf = Buffer.create (List.length l) in
  List.iter (fun c -> Buffer.add_char buf c) l;
  Buffer.contents buf;;

let stringTr: string -> char list
= fun s ->
	let rec f: int -> char list -> char list
	= fun i l ->
		if i >= 0
		then f (i - 1) ((String.get s i)::l)
		else l
	in
	f ((String.length s) - 1) []

let posTr: BinNums.positive -> Nb.Z.t
= fun p0 ->
	let rec f: int -> BinNums.positive -> Nb.Z.t
	= fun shift -> function
		| BinNums.Coq_xH -> Nb.Z.shiftL Nb.Z.u shift
		| BinNums.Coq_xO p -> f (shift + 1) p
		| BinNums.Coq_xI p ->
			let bit = Nb.Z.shiftL Nb.Z.u shift in
			let bits = f (shift + 1) p in
			Nb.Z.orL bit bits
	in
	f 0 p0

let posPr: BinNums.positive -> string
= fun p ->
	let z = posTr p in
	Nb.Z.pr z

let posPr': BinNums.positive -> char list
= fun p -> stringTr (posPr p)

let posPrRaw: BinNums.positive -> string
= fun p ->
	let rec pr l = function
		| BinNums.Coq_xH -> "xH"::l
		| BinNums.Coq_xI p -> pr ("xI"::l) p
		| BinNums.Coq_xO p -> pr ("xO"::l) p
	in
	String.concat " " (pr [] p)

let posPrRaw': BinNums.positive -> char list
= fun p -> stringTr (posPrRaw p)

let zTr: BinNums.coq_Z -> Nb.Z.t
= function
	| BinNums.Z0 -> Nb.Z.z
	| BinNums.Zpos p -> posTr p
	| BinNums.Zneg p -> Nb.Z.neg (posTr p)

let zPr: BinNums.coq_Z -> string
= fun z -> Nb.Z.pr (zTr z)

let zPr': BinNums.coq_Z -> char list
= fun z -> stringTr (zPr z)

let zPrRaw: BinNums.coq_Z -> string
= function
	| BinNums.Z0 -> "Z0"
	| BinNums.Zpos p -> Printf.sprintf "Zpos (%s)" (posPrRaw p)
	| BinNums.Zneg p -> Printf.sprintf "Zneg (%s)" (posPrRaw p)

let zPrRaw': BinNums.coq_Z -> char list
= fun z -> stringTr (zPrRaw z)
