let pToPedraQ: Pol.t -> PedraQ.BasicD.t
= fun p -> Some {PedraQ.BasicD.cons = Support.pToConsSet p; PedraQ.BasicD.ml = p}

let polChkSync: PedraQ.BasicD.t -> bool
= function
	| None -> true
	| Some p ->
		match pToPedraQ (PedraQ.BasicD.ml p) with
		| None -> failwith "Glue.polChkSync"
		| Some pML ->
			let norm: ConsSet.Cs.t -> ConsSet.Cs.t
			= fun cs ->
				let sort: ConsSet.Cs.t -> ConsSet.Cs.t
				= fun cs ->
					let cmp: ConsSet.Cs.cT -> ConsSet.Cs.cT -> int
					= fun c1 c2 -> Pervasives.compare (ConsSet.Cs.id c1) (ConsSet.Cs.id c2)
					in
					List.sort cmp cs
				in
                                (* TODO (from Sylvain): normDep does not exist anymore in the new implementation of linterms...
                                        but it may be useful to test the implicit invariant (by adding a test function in LinTerm.v)
				let norm1: ConsSet.Cs.cT -> ConsSet.Cs.cT
				= fun c ->
					{c with ConsSet.Cs.cstr =
						{(ConsSet.Cs.cstr c) with CstrC.Cstr.coefs =
							LinTerm.Lin.normDep (CstrC.Cstr.coefs (ConsSet.Cs.cstr c))}}
				in
				 *)
				sort cs (* Sylvain: (List.map norm1 cs) *)
			in
			let normP = norm (PedraQ.BasicD.cons p) in
			let normPML = norm (PedraQ.BasicD.cons pML) in
			normP = normPML

let addC: Pol.t -> Cstr.t -> PedraQ.BasicD.t
= fun p c ->
	let coqP = pToPedraQ p in
	let coqC = Support.cToCstrC c in
	PedraQ.CstrD.assume coqC coqP

let meet: Pol.t -> Pol.t -> PedraQ.BasicD.t
= fun p1 p2 -> PedraQ.BasicD.meet (pToPedraQ p1) (pToPedraQ p2)

let isInclC: Pol.t -> Pol.t -> bool
= fun p1 p2 -> PedraQ.BasicD.isIncl (pToPedraQ p1) (pToPedraQ p2)

let joinC: Pol.t -> Pol.t -> PedraQ.BasicD.t
= fun p1 p2 -> PedraQ.BasicD.join (pToPedraQ p1) (pToPedraQ p2)

let getItvC: Pol.t -> Vec.t -> Pol.itvT
= fun p v -> Support.iToItv (PedraQ.ItvD.getItv (pToPedraQ p) (Support.vecToLt v))

let project: Pol.t -> Var.t -> PedraQ.BasicD.t
= fun p1 x -> PedraQ.BasicD.project (pToPedraQ p1) (Support.varToProgVar x)

let projectM: Pol.t -> Var.t list -> Pol.t
= fun p l ->
	let (p', ce) = Pol.projectM p l in
	let cs = Support.pToConsSet p in
	let cs' = Support.pToConsSet p' in
	let ce' = Support.cToCertC ce in
	if ConsSet.Cs.chkIncl cs cs' ce'
	then p'
	else Pervasives.failwith "checking error"
