type t = Q.t

let z = Q.zero
let u = Q.one
let negU = Q.minus_one

let cmp = Q.compare
let cmpz q = -(Q.sign q)

let isZ : t -> bool
= fun n -> cmpz n = 0

let isReal = Q.is_real
let isInt n = Z.equal (Q.den n) Z.one

let abs = Q.abs
let neg = Q.neg
let inv = Q.inv

let add = Q.add
let sub = Q.sub
let mult = Q.mul
let div = Q.div

let of_float = Q.of_float
let ofQ : Q.t -> t = fun n -> n
let mk (den: int) (num: int) = Q.of_ints num den
let mk1 (num : int) = Q.of_ints num 1

let toQ : Q.t -> t
  = fun n -> n

let pr = Q.to_string

module Z =
struct
	type t = Z.t

	let z = Z.zero
	let u = Z.one

	let add : t -> t -> t
	= Z.add

	let sub : t -> t -> t
	= Z.sub

	let mul : t -> t -> t
	= Z.mul

	let div : t -> t -> t
	= Z.div

	let rem : t -> t -> t
	= Z.rem

	let cmp = Z.compare
	let equal = Z.equal
	let neg = Z.neg
	let gcd = Z.gcd
	let lAnd = Z.logand
	let orL = Z.logor
	let shiftL = Z.shift_left
	let shiftR = Z.shift_right

	let mk = Z.of_int

	let ofString : string -> t
	= Z.of_string

	let toInt = Z.to_int
	let pr = Z.to_string
end

let toZ a = (Q.num a, Q.den a)
let ofZ num den = Q.make num den

let gcd (nGcd, dGcd) a =
	((if Z.equal Z.u nGcd then
		Z.u
	else
		Z.gcd nGcd (Q.num a)),
	(if Z.equal Z.u dGcd then
		Z.u
	else
		Z.gcd dGcd (Q.den a)))
