type 'a mayFailT
=
	| Ok of 'a
	| Failed of string

let parse: string -> U.t list
= fun s ->
	let ch = Pervasives.open_in s in
	let lexbuf = Lexing.from_channel ch in
	DepParser.main DepLexer.token lexbuf

let findFile: string -> string
= fun f ->
	let prefix = Filename.chop_extension f in
	let depFile = prefix ^ ".d" in
	depFile

let filter: string -> U.t list -> U.t list
= fun m l ->
	let fn: U.t -> bool
	= fun d -> List.exists (fun f -> (Filename.basename f) = m) d.U.targets
	in
	let fn2: U.t -> U.t
	= fun d ->
		let mName = U.modName m in
		{d with U.prereqs = List.filter (fun m1 -> mName <> (U.modName m1)) d.U.prereqs}
	in
	List.map fn2 (List.filter fn l)

let gather: string -> string list mayFailT
= fun path ->
	let depF = findFile path in
	let rawL = parse depF in
	let l = filter (Filename.basename path) rawL in
	let allDeps = List.fold_left (fun a d -> List.append d.U.prereqs a) [] l in
	Ok allDeps
